commit:     4f2800b8ea16152c0eeb32dd270f3b2598b25f17
Author:     Volkmar W. Pogatzki <gentoo <AT> pogatzki <DOT> net>
AuthorDate: Mon Mar  4 13:25:20 2024 +0000
Commit:     Miroslav Šulc <fordfrog <AT> gentoo <DOT> org>
CommitDate: Thu Apr  4 07:48:05 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=4f2800b8

www-servers/tomcat: add 9.0.87-r2, unbundle bnd

- adds here document "build.properties" for configuration
- reduces the -build.xml.patch by using build.properties
- adds tomcat-9.0.87-gentoo-bnd.patch re-adding the unbundled parts
- removes the src_unpack() section
- removes -Dbnd.jar from EANT_EXTRA_ARGS
- updates eclipse-ecj 4.15 -> 4.20
- drops REWRITE_CLASSPATH, allows to drop -9.0.37-fix-build-rewrite.patch
- drops EANT_NEED_TOOLS
- removes the src_configure() section
- simplifies MY_P
- shortens verify-sig string by using MY_P
- unkeyword 9.0.87-r2 for ~x86

Signed-off-by: Volkmar W. Pogatzki <gentoo <AT> pogatzki.net>
Signed-off-by: Miroslav Šulc <fordfrog <AT> gentoo.org>

 .../tomcat/files/tomcat-9.0.87-build.xml.patch     |  30 ++++
 .../tomcat/files/tomcat-9.0.87-gentoo-bnd.patch    |  35 +++++
 www-servers/tomcat/tomcat-9.0.87-r2.ebuild         | 169 +++++++++++++++++++++
 3 files changed, 234 insertions(+)

diff --git a/www-servers/tomcat/files/tomcat-9.0.87-build.xml.patch 
b/www-servers/tomcat/files/tomcat-9.0.87-build.xml.patch
new file mode 100644
index 000000000000..354cfeaa190e
--- /dev/null
+++ b/www-servers/tomcat/files/tomcat-9.0.87-build.xml.patch
@@ -0,0 +1,30 @@
+1. we don't need commons-daemon
+2. jdt.jar is eclipse-ecj.jar which we provide as a separate package
+3. javadoc would fail without network access
+--- a/build.xml
++++ b/build.xml
+@@ -1451,7 +1451,6 @@
+   <target name="deploy" 
depends="package,build-docs,build-tomcat-jdbc,compile-webapp-examples"
+           description="Default. Builds a working Tomcat instance">
+ 
+-    <copy tofile="${tomcat.build}/bin/commons-daemon.jar" 
file="${commons-daemon.jar}" />
+ 
+     <!-- Copy scripts -->
+     <copy todir="${tomcat.build}/bin">
+@@ -1512,7 +1511,6 @@
+         <exclude name="${jdt.jar.filename}"/>
+       </fileset>
+     </delete>
+-    <copy file="${jdt.jar}" todir="${tomcat.build}/lib"/>
+ 
+     <!-- Add sources for examples -->
+     <antcall target="examples-sources" />
+@@ -2358,8 +2356,6 @@ Apache Tomcat ${version} native binaries for Win64 
AMD64/EMT64 platform.
+       <link href="../elapi"/>
+       <link href="../websocketapi"/>
+       <link href="../jaspicapi"/>
+-      <link href="https://docs.oracle.com/javase/8/docs/api/"/>
+-      <link href="https://javaee.github.io/javaee-spec/javadocs/"/>
+       <packageset dir="${tomcat.dist}/src/java/">
+         <include name="org/**"/>
+         <exclude name="org/apache/el/parser/**"/>

diff --git a/www-servers/tomcat/files/tomcat-9.0.87-gentoo-bnd.patch 
b/www-servers/tomcat/files/tomcat-9.0.87-gentoo-bnd.patch
new file mode 100644
index 000000000000..1d9ef0b0d0e8
--- /dev/null
+++ b/www-servers/tomcat/files/tomcat-9.0.87-gentoo-bnd.patch
@@ -0,0 +1,35 @@
+Gentoo's dev-java/bnd is unbundled. We're adding the parts here:
+--- a/build.xml
++++ b/build.xml
+@@ -225,7 +225,16 @@
+ 
+   <!-- Classpaths -->
+   <path id="compile.classpath">
++    <pathelement location="${ant.jar}"/>
+     <pathelement location="${bnd.jar}"/>
++    <pathelement location="${bnd-annotation.jar}"/>
++    <pathelement location="${bnd-ant.jar}"/>
++    <pathelement location="${bnd-util.jar}"/>
++    <pathelement location="${bndlib.jar}"/>
++    <pathelement location="${libg.jar}"/>
++    <pathelement location="${osgi-cmpn.jar}"/>
++    <pathelement location="${osgi-core.jar}"/>
++    <pathelement location="${slf4j-api.jar}"/>
+     <pathelement location="${jdt.jar}"/>
+     <pathelement location="${jaxrpc-lib.jar}"/>
+     <pathelement location="${wsdl4j-lib.jar}"/>
+@@ -3924,6 +3933,14 @@ Read the Building page on the Apache Tomcat 
documentation site for details on ho
+     <!-- Add bnd tasks to project -->
+     <path id="bnd.classpath">
+       <fileset file="${bnd.jar}" />
++      <fileset file="${bnd-annotation.jar}" />
++      <fileset file="${bnd-ant.jar}" />
++      <fileset file="${bnd-util.jar}" />
++      <fileset file="${bndlib.jar}" />
++      <fileset file="${libg.jar}" />
++      <fileset file="${osgi-cmpn.jar}" />
++      <fileset file="${osgi-core.jar}" />
++      <fileset file="${slf4j-api.jar}" />
+     </path>
+ 
+     <taskdef resource="aQute/bnd/ant/taskdef.properties" 
classpathref="bnd.classpath" />

diff --git a/www-servers/tomcat/tomcat-9.0.87-r2.ebuild 
b/www-servers/tomcat/tomcat-9.0.87-r2.ebuild
new file mode 100644
index 000000000000..6a5810add4af
--- /dev/null
+++ b/www-servers/tomcat/tomcat-9.0.87-r2.ebuild
@@ -0,0 +1,169 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+JAVA_PKG_IUSE="doc source test"
+
+inherit java-pkg-2 java-ant-2 prefix verify-sig
+
+MY_P="apache-${P}-src"
+
+DESCRIPTION="Tomcat Servlet-4.0/JSP-2.3/EL-3.0/WebSocket-1.1/JASPIC-1.1 
Container"
+HOMEPAGE="https://tomcat.apache.org/";
+SRC_URI="mirror://apache/${PN}/tomcat-9/v${PV}/src/${MY_P}.tar.gz
+       verify-sig? ( https://downloads.apache.org/tomcat/tomcat-$(ver_cut 
1)/v${PV}/src/${MY_P}.tar.gz.asc )"
+S=${WORKDIR}/${MY_P}
+
+LICENSE="Apache-2.0"
+SLOT="9"
+KEYWORDS="~amd64 ~arm ~arm64 ~amd64-linux ~x86-linux"
+IUSE="extra-webapps"
+
+RESTRICT="test" # can we run them on a production system?
+
+ECJ_SLOT="4.20"
+
+COMMON_DEP="dev-java/eclipse-ecj:${ECJ_SLOT}
+       dev-java/jax-rpc-api:0
+       dev-java/wsdl4j:0"
+RDEPEND="${COMMON_DEP}
+       acct-group/tomcat
+       acct-user/tomcat
+       >=virtual/jre-1.8:*"
+DEPEND="${COMMON_DEP}
+       app-admin/pwgen
+       >=dev-java/ant-1.10.14-r3:0
+       dev-java/bnd-annotation:0
+       dev-java/bnd-ant:0
+       dev-java/bnd-util:0
+       dev-java/bndlib:0
+       dev-java/libg:0
+       dev-java/osgi-cmpn:8
+       dev-java/osgi-core:0
+       dev-java/slf4j-api:0
+       >=virtual/jdk-17:*
+       test? (
+               >=dev-java/ant-1.10.14-r3:0[junit]
+               dev-java/easymock:3.2
+       )"
+
+BDEPEND="verify-sig? ( ~sec-keys/openpgp-keys-apache-tomcat-${PV}:${PV} )"
+VERIFY_SIG_OPENPGP_KEY_PATH="/usr/share/openpgp-keys/tomcat-${PV}.apache.org.asc"
+
+PATCHES=(
+       "${FILESDIR}/tomcat-9.0.87-build.xml.patch"
+       "${FILESDIR}/tomcat-9.0.87-gentoo-bnd.patch"
+)
+
+src_prepare() {
+       default #780585
+       java-pkg-2_src_prepare
+       java-pkg_clean
+
+       cat > build.properties <<-EOF || die
+               execute.download=false
+               exist=true # skip target="downloadfile-2"
+               ant.jar=$(java-pkg_getjar --build-only ant ant.jar)
+               bnd-annotation.jar=$(java-pkg_getjars --build-only 
bnd-annotation)
+               bnd-ant.jar=$(java-pkg_getjars --build-only bnd-ant)
+               bnd-util.jar=$(java-pkg_getjars --build-only bnd-util)
+               bnd.jar=$(java-pkg_getjars --build-only bnd)
+               bndlib.jar=$(java-pkg_getjars --build-only bndlib)
+               jaxrpc-lib.jar=$(java-pkg_getjars --build-only jax-rpc-api)
+               jdt.jar=$(java-pkg_getjars eclipse-ecj-${ECJ_SLOT})
+               libg.jar=$(java-pkg_getjars --build-only libg)
+               osgi-cmpn.jar=$(java-pkg_getjars --build-only osgi-cmpn-8)
+               osgi-core.jar=$(java-pkg_getjars --build-only osgi-core)
+               slf4j-api.jar=$(java-pkg_getjars --build-only slf4j-api)
+               wsdl4j-lib.jar=$(java-pkg_getjars wsdl4j)
+       EOF
+
+       # For use of catalina.sh in netbeans
+       sed -i -e "/^# ----- Execute The Requested Command/ a\
+               CLASSPATH=\`java-config --with-dependencies --classpath 
${PN}-${SLOT}\`" \
+               bin/catalina.sh || die
+}
+
+EANT_BUILD_TARGET="deploy"
+EANT_TEST_GENTOO_CLASSPATH="easymock-3.2"
+EANT_GENTOO_CLASSPATH_EXTRA="${S}/output/classes"
+EANT_EXTRA_ARGS="-Dversion=${PV}-gentoo -Dversion.number=${PV} 
-Dcompile.debug=false"
+
+# revisions of the scripts
+IM_REV="-r2"
+INIT_REV="-r1"
+
+src_compile() {
+       LC_ALL=C java-pkg-2_src_compile
+}
+
+src_test() {
+       java-pkg-2_src_test
+}
+
+src_install() {
+       local dest="/usr/share/${PN}-${SLOT}"
+
+       java-pkg_jarinto "${dest}"/bin
+       java-pkg_dojar output/build/bin/*.jar
+       exeinto "${dest}"/bin
+       doexe output/build/bin/*.sh
+
+       java-pkg_jarinto "${dest}"/lib
+       java-pkg_dojar output/build/lib/*.jar
+
+       dodoc RELEASE-NOTES RUNNING.txt
+       use doc && java-pkg_dojavadoc output/dist/webapps/docs/api
+       use source && java-pkg_dosrc java/*
+
+       ### Webapps ###
+
+       # add missing docBase
+       local apps="host-manager manager"
+       for app in ${apps}; do
+               sed -i -e "s|=\"true\" >|=\"true\" 
docBase=\"\$\{catalina.home\}/webapps/${app}\" >|" \
+                       output/build/webapps/${app}/META-INF/context.xml || die
+       done
+
+       insinto "${dest}"/webapps
+       doins -r output/build/webapps/{host-manager,manager,ROOT}
+       use extra-webapps && doins -r output/build/webapps/{docs,examples}
+
+       ### Config ###
+
+       # create "logs" directory in $CATALINA_BASE
+       # and set correct perms, see #458890
+       dodir "${dest}"/logs
+       fperms 0750 "${dest}"/logs
+
+       # replace the default pw with a random one, see #92281
+       local randpw="$(pwgen -s -B 15 1)"
+       sed -i -e "s|SHUTDOWN|${randpw}|" output/build/conf/server.xml || die
+
+       # prepend gentoo.classpath to common.loader, see #453212
+       sed -i -e 's/^common\.loader=/\0${gentoo.classpath},/' 
output/build/conf/catalina.properties || die
+
+       insinto "${dest}"
+       doins -r output/build/conf
+
+       ### rc ###
+
+       cp 
"${FILESDIR}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} 
"${T}" || die
+       eprefixify 
"${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash}
+       sed -i -e "s|@SLOT@|${SLOT}|g" 
"${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} || die
+
+       insinto "${dest}"/gentoo
+       doins "${T}"/tomcat.conf
+       exeinto "${dest}"/gentoo
+       newexe "${T}"/tomcat${INIT_REV}.init tomcat.init
+       newexe "${T}"/tomcat-instance-manager${IM_REV}.bash 
tomcat-instance-manager.bash
+}
+
+pkg_postinst() {
+       einfo "Ebuilds of Tomcat support running multiple instances. To manage 
Tomcat instances, run:"
+       einfo "  
${EPREFIX}/usr/share/${PN}-${SLOT}/gentoo/tomcat-instance-manager.bash --help"
+
+       einfo "Please read https://wiki.gentoo.org/wiki/Apache_Tomcat and"
+       einfo "https://wiki.gentoo.org/wiki/Project:Java/Tomcat_6_Guide for 
more information."
+}

Reply via email to